Index: framspy/evolalg_steps/base/frams_step.py
===================================================================
--- framspy/evolalg/base/frams_step.py	(revision 1182)
+++ framspy/evolalg_steps/base/frams_step.py	(revision 1185)
@@ -1,3 +1,3 @@
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 
 
Index: framspy/evolalg_steps/base/lambda_step.py
===================================================================
--- framspy/evolalg/base/lambda_step.py	(revision 1182)
+++ framspy/evolalg_steps/base/lambda_step.py	(revision 1185)
@@ -1,3 +1,3 @@
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 
 
Index: framspy/evolalg_steps/base/union_step.py
===================================================================
--- framspy/evolalg/base/union_step.py	(revision 1182)
+++ framspy/evolalg_steps/base/union_step.py	(revision 1185)
@@ -1,5 +1,5 @@
 from collections import Iterable
 
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 
 
Index: framspy/evolalg_steps/dissimilarity/archive.py
===================================================================
--- framspy/evolalg/dissimilarity/archive.py	(revision 1182)
+++ framspy/evolalg_steps/dissimilarity/archive.py	(revision 1185)
@@ -2,8 +2,8 @@
 from typing import Union
 
-from evolalg.base.step import Step
-from evolalg.dissimilarity.dissimilarity import Dissimilarity
-from evolalg.dissimilarity.frams_dissimilarity import FramsDissimilarity
-from evolalg.statistics.halloffame_custom import HallOfFameCustom
+from evolalg_steps.base.step import Step
+from evolalg_steps.dissimilarity.dissimilarity import Dissimilarity
+from evolalg_steps.dissimilarity.frams_dissimilarity import FramsDissimilarity
+from evolalg_steps.statistics.halloffame_custom import HallOfFameCustom
 
 # TODO not fully tested. Verify if works OK, in particular test adding new individuals.
Index: framspy/evolalg_steps/dissimilarity/dissimilarity.py
===================================================================
--- framspy/evolalg/dissimilarity/dissimilarity.py	(revision 1182)
+++ framspy/evolalg_steps/dissimilarity/dissimilarity.py	(revision 1185)
@@ -1,5 +1,5 @@
 from abc import ABC
 
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 import numpy as np
 
Index: framspy/evolalg_steps/dissimilarity/frams_dissimilarity.py
===================================================================
--- framspy/evolalg/dissimilarity/frams_dissimilarity.py	(revision 1182)
+++ framspy/evolalg_steps/dissimilarity/frams_dissimilarity.py	(revision 1185)
@@ -3,6 +3,6 @@
 import numpy as np
 
-from evolalg.base.frams_step import FramsStep
-from evolalg.dissimilarity.dissimilarity import Dissimilarity
+from evolalg_steps.base.frams_step import FramsStep
+from evolalg_steps.dissimilarity.dissimilarity import Dissimilarity
 
 
Index: framspy/evolalg_steps/dissimilarity/levenshtein.py
===================================================================
--- framspy/evolalg/dissimilarity/levenshtein.py	(revision 1182)
+++ framspy/evolalg_steps/dissimilarity/levenshtein.py	(revision 1185)
@@ -1,5 +1,5 @@
 import Levenshtein as lev
 
-from evolalg.dissimilarity.dissimilarity import Dissimilarity
+from evolalg_steps.dissimilarity.dissimilarity import Dissimilarity
 
 
Index: framspy/evolalg_steps/examples/multicriteria.py
===================================================================
--- framspy/evolalg/examples/multicriteria.py	(revision 1182)
+++ framspy/evolalg_steps/examples/multicriteria.py	(revision 1185)
@@ -19,20 +19,20 @@
 
 from FramsticksLib import FramsticksLib
-from evolalg.base.lambda_step import LambdaStep
-from evolalg.base.step import Step
-from evolalg.dissimilarity.frams_dissimilarity import FramsDissimilarity
-from evolalg.dissimilarity.levenshtein import LevenshteinDissimilarity
-from evolalg.experiment import Experiment
-from evolalg.fitness.fitness_step import FitnessStep
-from evolalg.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
-from evolalg.population.frams_population import FramsPopulation
-from evolalg.repair.remove.field import FieldRemove
-from evolalg.repair.remove.remove import Remove
-from evolalg.selection.nsga2 import NSGA2Selection
-from evolalg.statistics.halloffame_stats import HallOfFameStatistics
-from evolalg.statistics.multistatistics_deap import MultiStatistics
-from evolalg.statistics.statistics_deap import StatisticsDeap
-from evolalg.base.union_step import UnionStep
-from evolalg.utils.population_save import PopulationSave
+from evolalg_steps.base.lambda_step import LambdaStep
+from evolalg_steps.base.step import Step
+from evolalg_steps.dissimilarity.frams_dissimilarity import FramsDissimilarity
+from evolalg_steps.dissimilarity.levenshtein import LevenshteinDissimilarity
+from evolalg_steps.experiment import Experiment
+from evolalg_steps.fitness.fitness_step import FitnessStep
+from evolalg_steps.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
+from evolalg_steps.population.frams_population import FramsPopulation
+from evolalg_steps.repair.remove.field import FieldRemove
+from evolalg_steps.repair.remove.remove import Remove
+from evolalg_steps.selection.nsga2 import NSGA2Selection
+from evolalg_steps.statistics.halloffame_stats import HallOfFameStatistics
+from evolalg_steps.statistics.multistatistics_deap import MultiStatistics
+from evolalg_steps.statistics.statistics_deap import StatisticsDeap
+from evolalg_steps.base.union_step import UnionStep
+from evolalg_steps.utils.population_save import PopulationSave
 
 
Index: framspy/evolalg_steps/examples/niching_novelty.py
===================================================================
--- framspy/evolalg/examples/niching_novelty.py	(revision 1182)
+++ framspy/evolalg_steps/examples/niching_novelty.py	(revision 1185)
@@ -9,20 +9,20 @@
 
 from FramsticksLib import FramsticksLib
-from evolalg.base.lambda_step import LambdaStep
-from evolalg.base.step import Step
-from evolalg.dissimilarity.archive import ArchiveDissimilarity
-from evolalg.dissimilarity.frams_dissimilarity import FramsDissimilarity
-from evolalg.dissimilarity.levenshtein import LevenshteinDissimilarity
-from evolalg.experiment import Experiment
-from evolalg.fitness.fitness_step import FitnessStep
-from evolalg.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
-from evolalg.population.frams_population import FramsPopulation
-from evolalg.repair.remove.field import FieldRemove
-from evolalg.repair.remove.remove import Remove
-from evolalg.selection.tournament import TournamentSelection
-from evolalg.statistics.halloffame_stats import HallOfFameStatistics
-from evolalg.statistics.statistics_deap import StatisticsDeap
-from evolalg.base.union_step import UnionStep
-from evolalg.utils.population_save import PopulationSave
+from evolalg_steps.base.lambda_step import LambdaStep
+from evolalg_steps.base.step import Step
+from evolalg_steps.dissimilarity.archive import ArchiveDissimilarity
+from evolalg_steps.dissimilarity.frams_dissimilarity import FramsDissimilarity
+from evolalg_steps.dissimilarity.levenshtein import LevenshteinDissimilarity
+from evolalg_steps.experiment import Experiment
+from evolalg_steps.fitness.fitness_step import FitnessStep
+from evolalg_steps.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
+from evolalg_steps.population.frams_population import FramsPopulation
+from evolalg_steps.repair.remove.field import FieldRemove
+from evolalg_steps.repair.remove.remove import Remove
+from evolalg_steps.selection.tournament import TournamentSelection
+from evolalg_steps.statistics.halloffame_stats import HallOfFameStatistics
+from evolalg_steps.statistics.statistics_deap import StatisticsDeap
+from evolalg_steps.base.union_step import UnionStep
+from evolalg_steps.utils.population_save import PopulationSave
 
 
@@ -226,5 +226,5 @@
     if parsed_args.max_numconnections is not None:
         remove.append(NumConnectionsHigher(parsed_args.max_numconnections))
-    if parsed_args.max_numgenochars is not -1:
+    if parsed_args.max_numgenochars != -1:
         remove.append(NumCharsHigher(parsed_args.max_numgenochars))
 
Index: framspy/evolalg_steps/examples/standard.py
===================================================================
--- framspy/evolalg/examples/standard.py	(revision 1182)
+++ framspy/evolalg_steps/examples/standard.py	(revision 1185)
@@ -12,14 +12,14 @@
 
 from FramsticksLib import FramsticksLib
-from evolalg.base.union_step import UnionStep
-from evolalg.experiment import Experiment
-from evolalg.fitness.fitness_step import FitnessStep
-from evolalg.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
-from evolalg.population.frams_population import FramsPopulation
-from evolalg.repair.remove.field import FieldRemove
-from evolalg.selection.tournament import TournamentSelection
-from evolalg.statistics.halloffame_stats import HallOfFameStatistics
-from evolalg.statistics.statistics_deap import StatisticsDeap
-from evolalg.utils.population_save import PopulationSave
+from evolalg_steps.base.union_step import UnionStep
+from evolalg_steps.experiment import Experiment
+from evolalg_steps.fitness.fitness_step import FitnessStep
+from evolalg_steps.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
+from evolalg_steps.population.frams_population import FramsPopulation
+from evolalg_steps.repair.remove.field import FieldRemove
+from evolalg_steps.selection.tournament import TournamentSelection
+from evolalg_steps.statistics.halloffame_stats import HallOfFameStatistics
+from evolalg_steps.statistics.statistics_deap import StatisticsDeap
+from evolalg_steps.utils.population_save import PopulationSave
 
 
Index: framspy/evolalg_steps/experiment.py
===================================================================
--- framspy/evolalg/experiment.py	(revision 1182)
+++ framspy/evolalg_steps/experiment.py	(revision 1185)
@@ -2,11 +2,11 @@
 from typing import List, Callable, Union
 
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 import pickle
 import time
 
-from evolalg.base.union_step import UnionStep
-from evolalg.selection.selection import Selection
-from evolalg.utils.stable_generation import StableGeneration
+from evolalg_steps.base.union_step import UnionStep
+from evolalg_steps.selection.selection import Selection
+from evolalg_steps.utils.stable_generation import StableGeneration
 import logging
 
Index: framspy/evolalg_steps/fitness/fitness_step.py
===================================================================
--- framspy/evolalg/fitness/fitness_step.py	(revision 1182)
+++ framspy/evolalg_steps/fitness/fitness_step.py	(revision 1185)
@@ -1,6 +1,6 @@
 from typing import Dict, List
 
-from evolalg.base.frams_step import FramsStep
-from evolalg.base.individual import Individual
+from evolalg_steps.base.frams_step import FramsStep
+from evolalg_steps.base.individual import Individual
 import frams
 
Index: framspy/evolalg_steps/fitness/multiple_evaluations.py
===================================================================
--- framspy/evolalg/fitness/multiple_evaluations.py	(revision 1182)
+++ framspy/evolalg_steps/fitness/multiple_evaluations.py	(revision 1185)
@@ -1,6 +1,6 @@
 from typing import Dict, List
 
-from evolalg.base.individual import Individual
-from evolalg.fitness.fitness_step import FitnessStep
+from evolalg_steps.base.individual import Individual
+from evolalg_steps.fitness.fitness_step import FitnessStep
 import copy
 
Index: framspy/evolalg_steps/mutation_cross/frams_cross.py
===================================================================
--- framspy/evolalg/mutation_cross/frams_cross.py	(revision 1182)
+++ framspy/evolalg_steps/mutation_cross/frams_cross.py	(revision 1185)
@@ -1,6 +1,6 @@
 import random
 
-from evolalg.base.frams_step import FramsStep
-from evolalg.base.individual import Individual
+from evolalg_steps.base.frams_step import FramsStep
+from evolalg_steps.base.individual import Individual
 
 
Index: framspy/evolalg_steps/mutation_cross/frams_cross_and_mutate.py
===================================================================
--- framspy/evolalg/mutation_cross/frams_cross_and_mutate.py	(revision 1182)
+++ framspy/evolalg_steps/mutation_cross/frams_cross_and_mutate.py	(revision 1185)
@@ -1,5 +1,5 @@
-from evolalg.base.frams_step import FramsStep
-from evolalg.mutation_cross.frams_cross import FramsCross
-from evolalg.mutation_cross.frams_mutation import FramsMutation
+from evolalg_steps.base.frams_step import FramsStep
+from evolalg_steps.mutation_cross.frams_cross import FramsCross
+from evolalg_steps.mutation_cross.frams_mutation import FramsMutation
 
 
Index: framspy/evolalg_steps/mutation_cross/frams_cross_or_mutate.py
===================================================================
--- framspy/evolalg/mutation_cross/frams_cross_or_mutate.py	(revision 1182)
+++ framspy/evolalg_steps/mutation_cross/frams_cross_or_mutate.py	(revision 1185)
@@ -1,5 +1,5 @@
-from evolalg.base.frams_step import FramsStep
-from evolalg.mutation_cross.frams_cross import FramsCross
-from evolalg.mutation_cross.frams_mutation import FramsMutation
+from evolalg_steps.base.frams_step import FramsStep
+from evolalg_steps.mutation_cross.frams_cross import FramsCross
+from evolalg_steps.mutation_cross.frams_mutation import FramsMutation
 import random
 
Index: framspy/evolalg_steps/mutation_cross/frams_mutation.py
===================================================================
--- framspy/evolalg/mutation_cross/frams_mutation.py	(revision 1182)
+++ framspy/evolalg_steps/mutation_cross/frams_mutation.py	(revision 1185)
@@ -1,6 +1,6 @@
 import random
 
-from evolalg.base.frams_step import FramsStep
-from evolalg.base.individual import Individual
+from evolalg_steps.base.frams_step import FramsStep
+from evolalg_steps.base.individual import Individual
 
 
Index: framspy/evolalg_steps/population/frams_population.py
===================================================================
--- framspy/evolalg/population/frams_population.py	(revision 1182)
+++ framspy/evolalg_steps/population/frams_population.py	(revision 1185)
@@ -1,4 +1,4 @@
-from evolalg.base.frams_step import FramsStep
-from evolalg.base.individual import Individual
+from evolalg_steps.base.frams_step import FramsStep
+from evolalg_steps.base.individual import Individual
 
 
Index: framspy/evolalg_steps/repair/const.py
===================================================================
--- framspy/evolalg/repair/const.py	(revision 1182)
+++ framspy/evolalg_steps/repair/const.py	(revision 1185)
@@ -1,5 +1,5 @@
 import copy
 
-from evolalg.repair.repair import Repair
+from evolalg_steps.repair.repair import Repair
 
 
Index: framspy/evolalg_steps/repair/halloffame_repair.py
===================================================================
--- framspy/evolalg/repair/halloffame_repair.py	(revision 1182)
+++ framspy/evolalg_steps/repair/halloffame_repair.py	(revision 1185)
@@ -2,5 +2,5 @@
 import random
 
-from evolalg.repair import Repair
+from evolalg_steps.repair import Repair
 
 
Index: framspy/evolalg_steps/repair/multistep.py
===================================================================
--- framspy/evolalg/repair/multistep.py	(revision 1182)
+++ framspy/evolalg_steps/repair/multistep.py	(revision 1185)
@@ -1,3 +1,3 @@
-from evolalg.repair.repair import Repair
+from evolalg_steps.repair.repair import Repair
 import copy
 
Index: framspy/evolalg_steps/repair/mutate.py
===================================================================
--- framspy/evolalg/repair/mutate.py	(revision 1182)
+++ framspy/evolalg_steps/repair/mutate.py	(revision 1185)
@@ -2,5 +2,5 @@
 import copy
 
-from evolalg.repair.repair import Repair
+from evolalg_steps.repair.repair import Repair
 
 
Index: framspy/evolalg_steps/repair/remove/field.py
===================================================================
--- framspy/evolalg/repair/remove/field.py	(revision 1182)
+++ framspy/evolalg_steps/repair/remove/field.py	(revision 1185)
@@ -1,3 +1,3 @@
-from evolalg.repair.remove.remove import Remove
+from evolalg_steps.repair.remove.remove import Remove
 
 
Index: framspy/evolalg_steps/repair/remove/function.py
===================================================================
--- framspy/evolalg/repair/remove/function.py	(revision 1182)
+++ framspy/evolalg_steps/repair/remove/function.py	(revision 1185)
@@ -1,5 +1,4 @@
+from evolalg_steps.repair.remove.remove import Remove
 
-
-from evolalg.repair.remove.remove import Remove
 class LambdaRemove(Remove):
     def __init__(self, func, *args, **kwargs):
Index: framspy/evolalg_steps/repair/remove/remove.py
===================================================================
--- framspy/evolalg/repair/remove/remove.py	(revision 1182)
+++ framspy/evolalg_steps/repair/remove/remove.py	(revision 1185)
@@ -1,4 +1,4 @@
 from abc import abstractmethod
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 
 
Index: framspy/evolalg_steps/repair/repair.py
===================================================================
--- framspy/evolalg/repair/repair.py	(revision 1182)
+++ framspy/evolalg_steps/repair/repair.py	(revision 1185)
@@ -2,5 +2,5 @@
 from collections import Iterable
 
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 
 
Index: framspy/evolalg_steps/selection/identity.py
===================================================================
--- framspy/evolalg/selection/identity.py	(revision 1182)
+++ framspy/evolalg_steps/selection/identity.py	(revision 1185)
@@ -1,6 +1,6 @@
 import copy
 
-from evolalg.base.step import Step
-from evolalg.selection.selection import Selection
+from evolalg_steps.base.step import Step
+from evolalg_steps.selection.selection import Selection
 
 
Index: framspy/evolalg_steps/selection/nsga2.py
===================================================================
--- framspy/evolalg/selection/nsga2.py	(revision 1182)
+++ framspy/evolalg_steps/selection/nsga2.py	(revision 1185)
@@ -1,3 +1,3 @@
-from evolalg.selection.selection import Selection
+from evolalg_steps.selection.selection import Selection
 from deap import tools
 import copy
Index: framspy/evolalg_steps/selection/selection.py
===================================================================
--- framspy/evolalg/selection/selection.py	(revision 1182)
+++ framspy/evolalg_steps/selection/selection.py	(revision 1185)
@@ -1,5 +1,5 @@
 from abc import abstractmethod
 
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 import copy
 
Index: framspy/evolalg_steps/selection/tournament.py
===================================================================
--- framspy/evolalg/selection/tournament.py	(revision 1182)
+++ framspy/evolalg_steps/selection/tournament.py	(revision 1185)
@@ -1,8 +1,8 @@
-from evolalg.base.individual import Individual
+from evolalg_steps.base.individual import Individual
 from typing import List
 import random
 
-from evolalg.base.step import Step
-from evolalg.selection.selection import Selection
+from evolalg_steps.base.step import Step
+from evolalg_steps.selection.selection import Selection
 
 
Index: framspy/evolalg_steps/statistics/halloffame_stats.py
===================================================================
--- framspy/evolalg/statistics/halloffame_stats.py	(revision 1182)
+++ framspy/evolalg_steps/statistics/halloffame_stats.py	(revision 1185)
@@ -1,4 +1,4 @@
-from evolalg.statistics.halloffame_custom import HallOfFameCustom
-from evolalg.statistics.statistics import Statistics
+from evolalg_steps.statistics.halloffame_custom import HallOfFameCustom
+from evolalg_steps.statistics.statistics import Statistics
 
 
Index: framspy/evolalg_steps/statistics/multistatistics_deap.py
===================================================================
--- framspy/evolalg/statistics/multistatistics_deap.py	(revision 1182)
+++ framspy/evolalg_steps/statistics/multistatistics_deap.py	(revision 1185)
@@ -1,5 +1,5 @@
 from deap import tools
 
-from evolalg.statistics.statistics import Statistics
+from evolalg_steps.statistics.statistics import Statistics
 
 
Index: framspy/evolalg_steps/statistics/statistics.py
===================================================================
--- framspy/evolalg/statistics/statistics.py	(revision 1182)
+++ framspy/evolalg_steps/statistics/statistics.py	(revision 1185)
@@ -1,5 +1,5 @@
 from abc import abstractmethod
 
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 
 
Index: framspy/evolalg_steps/statistics/statistics_deap.py
===================================================================
--- framspy/evolalg/statistics/statistics_deap.py	(revision 1182)
+++ framspy/evolalg_steps/statistics/statistics_deap.py	(revision 1185)
@@ -1,5 +1,5 @@
 from deap import tools
 
-from evolalg.statistics.statistics import Statistics
+from evolalg_steps.statistics.statistics import Statistics
 
 
Index: framspy/evolalg_steps/utils/name_propagation.py
===================================================================
--- framspy/evolalg/utils/name_propagation.py	(revision 1182)
+++ framspy/evolalg_steps/utils/name_propagation.py	(revision 1185)
@@ -1,5 +1,5 @@
 from typing import Iterable, Union, List
 
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 import copy
 
Index: framspy/evolalg_steps/utils/population_save.py
===================================================================
--- framspy/evolalg/utils/population_save.py	(revision 1182)
+++ framspy/evolalg_steps/utils/population_save.py	(revision 1185)
@@ -1,3 +1,3 @@
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 import os
 from framsfiles import writer as framswriter
Index: framspy/evolalg_steps/utils/stable_generation.py
===================================================================
--- framspy/evolalg/utils/stable_generation.py	(revision 1182)
+++ framspy/evolalg_steps/utils/stable_generation.py	(revision 1185)
@@ -1,8 +1,8 @@
 from collections import Iterable
 
-from evolalg.base.step import Step
+from evolalg_steps.base.step import Step
 import copy
 
-from evolalg.base.union_step import UnionStep
+from evolalg_steps.base.union_step import UnionStep
 
 