Index: framspy/FramsticksLibCompetition.py
===================================================================
--- framspy/FramsticksLibCompetition.py	(revision 1206)
+++ framspy/FramsticksLibCompetition.py	(revision 1207)
@@ -15,5 +15,5 @@
 	- set SIMPLE_FITNESS_FORMAT = False below,
 	- edit FramsticksEvolution.py in a few places so that it only uses the FramsticksLibCompetition class instead of FramsticksLib,
-	- run: python FramsticksEvolution.py -path %DIR_WITH_FRAMS_LIBRARY%  -sim eval-allcriteria.sim;recording-body-coords.sim  -opt COGpath  -generations 20
+	- run: python FramsticksEvolution.py -path %DIR_WITH_FRAMS_LIBRARY%  -sim "eval-allcriteria.sim;deterministic.sim;recording-body-coords.sim"  -opt COGpath  -generations 20
 	See also: https://www.framsticks.com/gecco-competition
 	"""
Index: framspy/run-deap-examples.cmd
===================================================================
--- framspy/run-deap-examples.cmd	(revision 1206)
+++ framspy/run-deap-examples.cmd	(revision 1207)
@@ -9,9 +9,9 @@
 
 rem simple one-criterion evolution, maximize the number of neurons
-python FramsticksEvolution.py   -path %DIR_WITH_FRAMS_LIBRARY%   -sim eval-allcriteria.sim  -opt numneurons
+python FramsticksEvolution.py   -path %DIR_WITH_FRAMS_LIBRARY%   -sim "eval-allcriteria.sim"  -opt numneurons
  
 
 rem as above but "chaining" .sim files, subsequent files overwrite selected parameters
-python FramsticksEvolution.py   -path %DIR_WITH_FRAMS_LIBRARY%   -sim eval-allcriteria.sim;deterministic.sim;sample-period-longest.sim    -opt velocity
+python FramsticksEvolution.py   -path %DIR_WITH_FRAMS_LIBRARY%   -sim "eval-allcriteria.sim;deterministic.sim;sample-period-longest.sim"    -opt velocity
 
 
Index: framspy/run-evolalg-examples.cmd
===================================================================
--- framspy/run-evolalg-examples.cmd	(revision 1206)
+++ framspy/run-evolalg-examples.cmd	(revision 1207)
@@ -9,11 +9,11 @@
 
 rem evolution with niching
-python -m evolalg.run_frams_niching  -path %DIR_WITH_FRAMS_LIBRARY%  -sim eval-allcriteria.sim;deterministic.sim;sample-period-longest.sim -opt velocity -genformat 0 -dissim 1 -fit knn_niching -archive 50 -max_numparts 15 -max_numneurons 15 -max_numjoints 30 -max_numconnections 30  -max_numgenochars 10000 -popsize 50 -generations 10 -normalize none -hof_savefile HoF-niching.gen 
+python -m evolalg.run_frams_niching  -path %DIR_WITH_FRAMS_LIBRARY%  -sim "eval-allcriteria.sim;deterministic.sim;sample-period-longest.sim" -opt velocity -genformat 0 -dissim 1 -fit knn_niching -archive 50 -max_numparts 15 -max_numneurons 15 -max_numjoints 30 -max_numconnections 30  -max_numgenochars 10000 -popsize 50 -generations 10 -normalize none -hof_savefile HoF-niching.gen 
 
 rem a generic island model example
-python -m evolalg.run_frams_islands  -path %DIR_WITH_FRAMS_LIBRARY%  -islands=10 -generations_migration=5 -sim eval-allcriteria.sim;only-body.sim;deterministic.sim;sample-period-2.sim -opt vertpos -genformat 1 -max_numparts 15 -max_numneurons 15 -max_numjoints 5 -max_numconnections 5  -max_numgenochars 100 -popsize 20 -generations 15  -hof_savefile HoF-islands.gen
+python -m evolalg.run_frams_islands  -path %DIR_WITH_FRAMS_LIBRARY%  -islands=10 -generations_migration=5 -sim "eval-allcriteria.sim;only-body.sim;deterministic.sim;sample-period-2.sim" -opt vertpos -genformat 1 -max_numparts 15 -max_numneurons 15 -max_numjoints 5 -max_numconnections 5  -max_numgenochars 100 -popsize 20 -generations 15  -hof_savefile HoF-islands.gen
 
 rem a combination of various parameters for thorough testing, see source of 'test_diferent_settings.py'
-rem python -m evolalg.tests.test_diferent_settings  -path %DIR_WITH_FRAMS_LIBRARY%  -sim eval-allcriteria.sim
+rem python -m evolalg.tests.test_diferent_settings  -path %DIR_WITH_FRAMS_LIBRARY%  -sim "eval-allcriteria.sim"
 
 
Index: framspy/run-evolalg_steps-examples.cmd
===================================================================
--- framspy/run-evolalg_steps-examples.cmd	(revision 1206)
+++ framspy/run-evolalg_steps-examples.cmd	(revision 1207)
@@ -13,5 +13,5 @@
 
 rem as above but "chaining" .sim files, subsequent files overwrite selected parameters
-python -m evolalg_steps.examples.standard          -path %DIR_WITH_FRAMS_LIBRARY%   -sim eval-allcriteria.sim;deterministic.sim;sample-period-longest.sim    -opt velocity
+python -m evolalg_steps.examples.standard          -path %DIR_WITH_FRAMS_LIBRARY%   -sim "eval-allcriteria.sim;deterministic.sim;sample-period-longest.sim"    -opt velocity
 
 